local addonName, ns = ...
local _G = _G
local setfenv = _G.setfenv
local addon = ns.addon
setfenv(1, addon)

addon.modules = {}
local modules = addon.modules

function addon:createModule(name, template, ...)
    -- Note that AceAddon3:NewModule creates a shallow copy of the template.
    -- This is not sufficient, hence we need to make a deepcopy first
    local templateCopy = ns.deepCopy(template)
    local module = addon:NewModule(name, templateCopy, 'AceHook-3.0',...)
    self:registerModule(name, module)
    return module
end

function addon:registerModule(name, module)
    modules[name] = module
    addon.optionsTable.args[name] = {
        name = name,
        desc = module.optionsTable.desc,
        type = "toggle",
        get = 'getEnable',
        set = 'setEnable',
        handler = module,
    }
end